local money = GetMoney()
local moneynext = GetMoney()
local diff = money -moneynext
local moneyActive = false
local totalmoney = 0
local _, L,MyAddon = ...;

MyAddon.moneyAct = MyAddon:CreateFontString(nil, "OVERLAY", "GameFontNormal")
MyAddon.moneyAct:SetPoint("TOPLEFT",MyAddon,"TOPLEFT",20,-30)
MyAddon.moneyAct:SetText(L["InitMoney"] .. GetCoinTextureString(money))

MyAddon.moneyEarned = MyAddon:CreateFontString(nil, "OVERLAY", "GameFontNormal")
MyAddon.moneyEarned:SetPoint("TOPLEFT",MyAddon,"TOPLEFT",20,-60)
MyAddon.moneyEarned:SetText(L["EarnedMoney"] .. GetCoinTextureString(diff))

MyAddon.startMoney = CreateFrame("button","StartMoneyButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.startMoney:SetHeight(24)
MyAddon.startMoney:SetWidth(80)
MyAddon.startMoney:SetPoint("TOPLEFT", MyAddon, "TOPLEFT", 15, -100)
MyAddon.startMoney:SetText(L["Start"])
MyAddon.startMoney:SetScript("OnClick", function (self, button, down)
    StartMoneyCGF()
    end)
MyAddon.pauseMoney = CreateFrame("button","PauseMoneyButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.pauseMoney:SetHeight(24)
MyAddon.pauseMoney:SetWidth(80)
MyAddon.pauseMoney:SetPoint("TOP", MyAddon, "TOP", 0, -100)
MyAddon.pauseMoney:SetText(L["Pause"])
MyAddon.pauseMoney:Hide()
MyAddon.pauseMoney:SetScript("OnClick", function (self, button, down)
    PauseMoneyCGF()
    end)
MyAddon.replayMoney = CreateFrame("button","PauseMoneyButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.replayMoney:SetHeight(24)
MyAddon.replayMoney:SetWidth(90)
MyAddon.replayMoney:SetPoint("TOP", MyAddon, "TOP", 0, -100)
MyAddon.replayMoney:SetText(L["Resume"])
MyAddon.replayMoney:Hide()
MyAddon.replayMoney:SetScript("OnClick", function (self, button, down)
    ReplayMoneyCGF()
end)
MyAddon.resetMoney = CreateFrame("button","resetMoneyButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.resetMoney:SetHeight(24)
MyAddon.resetMoney:SetWidth(80)
MyAddon.resetMoney:SetPoint("TOPRIGHT", MyAddon, "TOPRIGHT", -15, -100)
MyAddon.resetMoney:SetText(L["Finish"])
MyAddon.resetMoney:Disable()
MyAddon.resetMoney:SetScript("OnClick", function (self, button, down)
    resetMoneyCGF()
end)

StartMoneyCGF = function(self)
    print(L["StartRun"])
    money = GetMoney()
    moneynext = GetMoney()
    diff = moneynext - money
    totalmoney = diff
    MyAddon.moneyAct:SetText(L["InitMoney"] .. GetCoinTextureString(money))
    MyAddon.moneyEarned:SetText(L["EarnedMoney"] .. GetCoinTextureString(totalmoney))
    MyAddon.pauseMoney:Show()
    MyAddon.resetMoney:Enable()
    MyAddon.startMoney:Disable()
    moneyActive = true
end

PauseMoneyCGF = function(self)
    
    totalmoney = totalmoney + diff
    moneyActive = false
    MyAddon.moneyEarned:SetText(L["EarnedMoney"] .. GetCoinTextureString(totalmoney))
    MyAddon.pauseMoney:Hide()
    MyAddon.replayMoney:Show()
end

ReplayMoneyCGF = function(self)
    moneyActive = true
    MyAddon.pauseMoney:Show()
    MyAddon.replayMoney:Hide()
end

resetMoneyCGF = function(self)
    print(L["ResetData"])
    money = GetMoney()
    moneynext = GetMoney()
    diff = 0
    totalmoney = 0
    MyAddon.moneyAct:SetText(L["InitMoney"] .. GetCoinTextureString(money))
    MyAddon.moneyEarned:SetText(L["EarnedMoney"] .. GetCoinTextureString(totalmoney))
    MyAddon.pauseMoney:Hide()
    MyAddon.replayMoney:Hide()
    MyAddon.resetMoney:Disable()
    MyAddon.startMoney:Enable()
    
end

-- Eventos

local frame = CreateFrame("Frame")
frame:RegisterEvent("PLAYER_MONEY")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:SetScript("OnEvent", function(self, event, ...)
    if moneyActive == true then
        moneynext = GetMoney()
        diff = (moneynext - (money + totalmoney));
        local lodiff = diff + totalmoney
        MyAddon.moneyEarned:SetText(L["EarnedMoney"] .. GetCoinTextureString(lodiff))
    end
   
end)