local _, L = ...;
local money = GetMoney()
local moneynext = GetMoney()
local diff = money -moneynext
local difftime = 0
local totalmoney = 0
local inLockdown = false
local activeAddon = false
local timer = GetTime();
local totalseconds = 0;
local seconds = 0
local minutes = 0
local timerActive = false
local moneyActive = false
local MyAddon = CreateFrame("frame","MyAddonFrame")
MyAddon:SetBackdrop({
      bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
      edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
      tile=1, tileSize=32, edgeSize=32, 
      insets={left=11, right=12, top=12, bottom=11}
})
MyAddon:RegisterEvent("PLAYER_ENTERING_WORLD")
MyAddon:SetWidth(300)
MyAddon:SetHeight(250)
MyAddon:SetPoint("CENTER",UIParent)
MyAddon:EnableMouse(true)
MyAddon:SetMovable(true)
MyAddon:RegisterForDrag("LeftButton")
MyAddon:SetScript("OnDragStart", function(self) self:StartMoving() end)
MyAddon:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
MyAddon:SetFrameStrata("FULLSCREEN_DIALOG")
MyAddon:SetScript("OnUpdate", function(self) 
   if timerActive == true then
        local timeup = math.floor(GetTime())
        difftime = (timeup - math.floor(timer))
        seconds = (difftime + totalseconds) % 60
        minutes = (difftime + totalseconds)/60
        
        MyAddon.timer:SetText(format(L["Timer"], minutes,seconds ))
   end

end)

-- MyAddon.FrameRun = CreateFrame("frame","MyAddonFrameRun",MyAddon)
-- MyAddon.FrameRun:SetBackdrop({
--     bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
--     edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
--     tile=1, tileSize=32, edgeSize=32, 
--     insets={left=11, right=12, top=12, bottom=11}
-- })
-- MyAddon.FrameRun:RegisterEvent("PLAYER_ENTERING_WORLD")
-- MyAddon.FrameRun:SetWidth(100)
-- MyAddon.FrameRun:SetHeight(250)
-- MyAddon.FrameRun:SetPoint("CENTER",UIParent)
-- MyAddon.FrameRun:EnableMouse(true)
-- MyAddon.FrameRun:SetMovable(true)
-- MyAddon.FrameRun:SetFrameStrata("FULLSCREEN_DIALOG")

MyAddon:Hide();

MyAddon.closed = CreateFrame("button","closedButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.closed:SetHeight(24)
MyAddon.closed:SetWidth(24)
MyAddon.closed:SetPoint("TOPRIGHT", MyAddon, "TOPRIGHT", -5, -5)
MyAddon.closed:SetText("X")
MyAddon.closed:SetScript("OnClick", function(self) self:GetParent():Hide() activeAddon =false end)

-- Dinero

MyAddon.moneyAct = MyAddon:CreateFontString(nil, "OVERLAY", "GameFontNormal")
MyAddon.moneyAct:SetPoint("TOPLEFT",MyAddon,"TOPLEFT",20,-30)
MyAddon.moneyAct:SetText(L["InitMoney"] .. GetCoinTextureString(money))

MyAddon.moneyEarned = MyAddon:CreateFontString(nil, "OVERLAY", "GameFontNormal")
MyAddon.moneyEarned:SetPoint("TOPLEFT",MyAddon,"TOPLEFT",20,-60)
MyAddon.moneyEarned:SetText(L["EarnedMoney"] .. GetCoinTextureString(diff))

MyAddon.startMoney = CreateFrame("button","StartMoneyButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.startMoney:SetHeight(24)
MyAddon.startMoney:SetWidth(80)
MyAddon.startMoney:SetPoint("TOPLEFT", MyAddon, "TOPLEFT", 15, -100)
MyAddon.startMoney:SetText(L["Start"])
MyAddon.startMoney:SetScript("OnClick", function (self, button, down)
    StartMoneyCGF()
    end)
MyAddon.pauseMoney = CreateFrame("button","PauseMoneyButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.pauseMoney:SetHeight(24)
MyAddon.pauseMoney:SetWidth(80)
MyAddon.pauseMoney:SetPoint("TOP", MyAddon, "TOP", 0, -100)
MyAddon.pauseMoney:SetText(L["Pause"])
MyAddon.pauseMoney:Hide()
MyAddon.pauseMoney:SetScript("OnClick", function (self, button, down)
    PauseMoneyCGF()
    end)
MyAddon.replayMoney = CreateFrame("button","PauseMoneyButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.replayMoney:SetHeight(24)
MyAddon.replayMoney:SetWidth(90)
MyAddon.replayMoney:SetPoint("TOP", MyAddon, "TOP", 0, -100)
MyAddon.replayMoney:SetText(L["Resume"])
MyAddon.replayMoney:Hide()
MyAddon.replayMoney:SetScript("OnClick", function (self, button, down)
    ReplayMoneyCGF()
end)
MyAddon.resetMoney = CreateFrame("button","resetMoneyButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.resetMoney:SetHeight(24)
MyAddon.resetMoney:SetWidth(80)
MyAddon.resetMoney:SetPoint("TOPRIGHT", MyAddon, "TOPRIGHT", -15, -100)
MyAddon.resetMoney:SetText(L["Finish"])
MyAddon.resetMoney:Disable()
MyAddon.resetMoney:SetScript("OnClick", function (self, button, down)
    resetMoneyCGF()
end)

StartMoneyCGF = function(self)
    print(L["StartRun"])
    money = GetMoney()
    moneynext = GetMoney()
    diff = moneynext - money
    totalmoney = diff
    MyAddon.moneyAct:SetText(L["InitMoney"] .. GetCoinTextureString(money))
    MyAddon.moneyEarned:SetText(L["EarnedMoney"] .. GetCoinTextureString(totalmoney))
    MyAddon.pauseMoney:Show()
    MyAddon.resetMoney:Enable()
    MyAddon.startMoney:Disable()
    moneyActive = true
end

PauseMoneyCGF = function(self)
    
    totalmoney = totalmoney + diff
    moneyActive = false
    MyAddon.moneyEarned:SetText(L["EarnedMoney"] .. GetCoinTextureString(totalmoney))
    MyAddon.pauseMoney:Hide()
    MyAddon.replayMoney:Show()
end

ReplayMoneyCGF = function(self)
    moneyActive = true
    MyAddon.pauseMoney:Show()
    MyAddon.replayMoney:Hide()
end

resetMoneyCGF = function(self)
    print(L["ResetData"])
    money = GetMoney()
    moneynext = GetMoney()
    diff = 0
    totalmoney = 0
    MyAddon.moneyAct:SetText(L["InitMoney"] .. GetCoinTextureString(money))
    MyAddon.moneyEarned:SetText(L["EarnedMoney"] .. GetCoinTextureString(totalmoney))
    MyAddon.pauseMoney:Hide()
    MyAddon.replayMoney:Hide()
    MyAddon.resetMoney:Disable()
    MyAddon.startMoney:Enable()
    
end

-- Timer

MyAddon.start = CreateFrame("button","StartButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.start:SetHeight(24)
MyAddon.start:SetWidth(80)
MyAddon.start:SetPoint("BOTTOMLEFT", MyAddon, "BOTTOMLEFT", 15, 15)
MyAddon.start:SetText(L["Start"])
MyAddon.start:SetScript("OnClick", function (self, button, down)
    StartCGF()
    end)
MyAddon.pause = CreateFrame("button","PauseButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.pause:SetHeight(24)
MyAddon.pause:SetWidth(80)
MyAddon.pause:SetPoint("BOTTOM", MyAddon, "BOTTOM", 0, 15)
MyAddon.pause:SetText(L["Pause"])
MyAddon.pause:Hide()
MyAddon.pause:SetScript("OnClick", function (self, button, down)
    PauseCGF()
    end)
MyAddon.replay = CreateFrame("button","PauseButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.replay:SetHeight(24)
MyAddon.replay:SetWidth(90)
MyAddon.replay:SetPoint("BOTTOM", MyAddon, "BOTTOM", 0, 15)
MyAddon.replay:SetText(L["Resume"])
MyAddon.replay:Hide()
MyAddon.replay:SetScript("OnClick", function (self, button, down)
    ReplayCGF()
end)
MyAddon.reset = CreateFrame("button","resetButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.reset:SetHeight(24)
MyAddon.reset:SetWidth(80)
MyAddon.reset:SetPoint("BOTTOMRIGHT", MyAddon, "BOTTOMRIGHT", -15, 15)
MyAddon.reset:SetText(L["Finish"])
MyAddon.reset:SetScript("OnClick", function (self, button, down)
    resetCGF()
end)

MyAddon.timer = MyAddon:CreateFontString(nil, "OVERLAY", "GameFontNormal")
MyAddon.timer:SetPoint("BOTTOM",MyAddon,"BOTTOM",0,50)
MyAddon.timer:SetText(format(L["Timer"], minutes,seconds ))

resetTimer = function(self)
    timerActive = false
    miliseconds = 0
    seconds = 0
    minutes = 0
    timer = 0;
    difftime = 0
    MyAddon.timer:SetText(format(L["Timer"], minutes,seconds ))
end

StartCGF = function(self)
    resetTimer()
    timer = GetTime()
    timerActive = true
    MyAddon.pause:Show()
    MyAddon.reset:Enable()
    MyAddon.start:Disable()
end

PauseCGF = function(self)
    timerActive = false
    totalseconds = totalseconds + difftime
    difftime = 0;
    seconds = totalseconds % 60
    minutes = totalseconds/60
    MyAddon.timer:SetText(format(L["Timer"], minutes,seconds ))
    MyAddon.pause:Hide()
    MyAddon.replay:Show()
end

ReplayCGF = function(self)
    timerActive = true
    timer = math.floor(GetTime())
    MyAddon.pause:Show()
    MyAddon.replay:Hide()
end

resetCGF = function(self)
    print(L["ResetData"])
    resetTimer()
    MyAddon.pause:Hide()
    MyAddon.replay:Hide()
    MyAddon.reset:Disable()
    MyAddon.start:Enable()
end

-- Eventos

local frame = CreateFrame("Frame")
frame:RegisterEvent("PLAYER_MONEY")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:SetScript("OnEvent", function(self, event, ...)
    if moneyActive == true then
        moneynext = GetMoney()
        diff = (moneynext - (money + totalmoney));
        local lodiff = diff + totalmoney
        MyAddon.moneyEarned:SetText(L["EarnedMoney"] .. GetCoinTextureString(lodiff))
    end
   
end)

-- local hiddenAddon = CreateFrame("Frame")
-- hiddenAddon:RegisterEvent("PLAYER_REGEN_DISABLED")
-- hiddenAddon:RegisterEvent("PLAYER_ENTERING_WORLD")
-- hiddenAddon:SetScript("OnEvent", function(self, event, ...)
--     --MyAddon:Hide();
--     inLockdown = true
-- end)

-- local ShowAddon = CreateFrame("Frame")
-- ShowAddon:RegisterEvent("PLAYER_REGEN_ENABLED")
-- ShowAddon:RegisterEvent("PLAYER_ENTERING_WORLD")
-- ShowAddon:SetScript("OnEvent", function(self, event, ...)
--     if activeAddon then
--         MyAddon:Show();
--     end
--     inLockdown = false
-- end)

SLASH_CGFSTART1 = "/cgf"
SlashCmdList["CGFSTART"] = function(self, txt)
    if inLockdown == false then
        MyAddon:Show()
        activeAddon = true
    end
    
end

-- SLASH_CGFSTOP1 = "/cgfstop"
-- SlashCmdList["CGFSTOP"] = function(self, txt)
--     moneynext = GetMoney()
--     diff = money - moneynext
--     local gold = floor(abs(diff / 10000))
--     local silver = floor(abs(mod(diff / 100, 100)))
--     local copper = floor(abs(mod(diff, 100)))
--     message(format("Has ganado en total |cff00FF00%d oro %d plata %d cobre.", gold, silver, copper))
--     print(format("Has ganado en total |cff00FF00%d oro %d plata %d cobre.", gold, silver, copper))
-- end