local timer = GetTime();
local totalseconds = 0;
local seconds = 0
local minutes = 0
local timerActive = false
local difftime = 0
local _, L,MyAddon = ...;

MyAddon.start = CreateFrame("button","StartButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.start:SetHeight(24)
MyAddon.start:SetWidth(80)
MyAddon.start:SetPoint("BOTTOMLEFT", MyAddon, "BOTTOMLEFT", 15, 15)
MyAddon.start:SetText(L["Start"])
MyAddon.start:SetScript("OnClick", function (self, button, down)
    StartCGF()
    end)
MyAddon.pause = CreateFrame("button","PauseButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.pause:SetHeight(24)
MyAddon.pause:SetWidth(80)
MyAddon.pause:SetPoint("BOTTOM", MyAddon, "BOTTOM", 0, 15)
MyAddon.pause:SetText(L["Pause"])
MyAddon.pause:Hide()
MyAddon.pause:SetScript("OnClick", function (self, button, down)
    PauseCGF()
    end)
MyAddon.replay = CreateFrame("button","PauseButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.replay:SetHeight(24)
MyAddon.replay:SetWidth(90)
MyAddon.replay:SetPoint("BOTTOM", MyAddon, "BOTTOM", 0, 15)
MyAddon.replay:SetText(L["Resume"])
MyAddon.replay:Hide()
MyAddon.replay:SetScript("OnClick", function (self, button, down)
    ReplayCGF()
end)
MyAddon.reset = CreateFrame("button","resetButton", MyAddon, "UIPanelButtonTemplate")
MyAddon.reset:SetHeight(24)
MyAddon.reset:SetWidth(80)
MyAddon.reset:SetPoint("BOTTOMRIGHT", MyAddon, "BOTTOMRIGHT", -15, 15)
MyAddon.reset:SetText(L["Finish"])
MyAddon.reset:SetScript("OnClick", function (self, button, down)
    resetCGF()
end)

MyAddon.timer = MyAddon:CreateFontString(nil, "OVERLAY", "GameFontNormal")
MyAddon.timer:SetPoint("BOTTOM",MyAddon,"BOTTOM",0,50)
MyAddon.timer:SetText(format(L["Timer"], minutes,seconds ))

resetTimer = function(self)
    timerActive = false
    miliseconds = 0
    seconds = 0
    minutes = 0
    timer = 0;
    difftime = 0
    MyAddon.timer:SetText(format(L["Timer"], minutes,seconds ))
end

StartCGF = function(self)
    resetTimer()
    timer = GetTime()
    timerActive = true
    MyAddon.pause:Show()
    MyAddon.reset:Enable()
    MyAddon.start:Disable()
end

PauseCGF = function(self)
    timerActive = false
    totalseconds = totalseconds + difftime
    difftime = 0;
    seconds = totalseconds % 60
    minutes = totalseconds/60
    MyAddon.timer:SetText(format(L["Timer"], minutes,seconds ))
    MyAddon.pause:Hide()
    MyAddon.replay:Show()
end

ReplayCGF = function(self)
    timerActive = true
    timer = math.floor(GetTime())
    MyAddon.pause:Show()
    MyAddon.replay:Hide()
end

resetCGF = function(self)
    print(L["ResetData"])
    resetTimer()
    MyAddon.pause:Hide()
    MyAddon.replay:Hide()
    MyAddon.reset:Disable()
    MyAddon.start:Enable()
end